#!/usr/bin/env ruby
# HTTP-getter(with cookie)
# wgetǂBwebagentɊSˑŃ``ƍ쐬
#

require 'net/http'
require 'cgi'
require './simpleuri.rb'
require './webagent.rb'

#----- def argopt -----
def argopt ( argv, opt2v )
  argopt0 = []
  argopt1 = []
  argopt2 = []
  num = '0123456789'

  flag = false
  argv.each { |arg|
    if (arg =~ /^-/) && ((arg[1] < num[0]) || (arg[1] > num[-1])) then
      flag = false
      opt2v.each { |opt|
        flag = true if arg == opt
      }
      if flag == false then
        argopt1 << arg
      else
        argopt2 << arg
      end
    else
      if flag == false then
        argopt0 << arg
      else
        argopt2 << arg
      end
      flag = false
    end
  }
  newargopt2 = []
  0.upto(argopt2.size - 2) { |i|
    tmp = []
    tmp << argopt2[i]
    if argopt2[i+1] !~ /^-/
      tmp << argopt2[i+1]
      i = i + 1
    end
    newargopt2 << tmp
  }
  if argopt2[argopt2.size - 1] =~ /^-/
    newargopt2 << argopt2[argopt2.size - 1]
  end
  
  argopts = []
  argopts << argopt0 << argopt1 << newargopt2

  return argopts
end

def file_fromurl( url )
  tmp = url.gsub(/^http:\/\//,'')
  if tmp =~ /.+?\/(.+?)$/
    tmp = $1
  else
    tmp = ''
  end
  file      = File.basename(tmp)
  file_base = File.basename(tmp)
  if file == ''
    file      = 'index.html'
    file_base = 'index.html'
  end
  count = 1
  while File.exist?(file) == true
    file = file_base + '.' + count.to_s
    count = count + 1
  end
  return file
end

#----- check arg -----
usage = 'command  input-url [-f(ile) input-list.txt] (-> output.htm) [output.html]'
opt2v = ['-f', '-file']

input_list = nil
argopts = argopt ( ARGV, opt2v )
argopts[2].each { |option, value|
  if (option == "-f") || (option == "-file") then
    input_list = open(value).readlines
    input_list.collect!{ |line| line.chomp! }
    if input_list.size < 10
      $stderr.puts "CHK; download-list"
      $stderr.puts input_list.join("\n")
    else
      $stderr.puts "CHK; download-file " + input_list.size.to_s + "-file."
    end
  end
}
case argopts[0].size
when 0
  if input_list.nil?
    $stderr.puts "Usage: " << usage
    exit 1
  end
when 1
  input  = argopts[0][0]
when 2
  input  = argopts[0][0]
  output = argopts[0][1]
else
  $stderr.puts "Usage: " << usage
  exit 1
end
argopts[1].each { |option|
  if (option == "-h") || (option == "-help") then
    $stderr.puts "Usage: " << usage
    exit 1
  end
}
if !input.nil? then
  $stderr.puts "CHK; input;     " << input.to_s
  input_list = [] if input_list.nil?
  input_list << input
end
if !output.nil? then
  $stderr.puts "CHK; output;    " << output.to_s
end

#----- main -----
agent = WebAgent.new()
input_list.each { |url|
  agent.uri = url
  $stderr.print "CHK; download- " + url
  begin
    agent.get()
    file = file_fromurl(url)
    open(file, "w") { |fp| fp.print agent.body }
    $stderr.print " -> " + file
    $stderr.puts
  rescue
    $stderr.puts
    $stderr.puts "ERR; download- " + url
  end
}
